function bench(d,LN,varargin)
  % function bench(d,LN)
  %   d: dimension
  %  type: 'orthotope' or 'simplex'
  %  box: 
  p = inputParser;
  p.PartialMatching=false;
  p.addParamValue('type', 'simplex', @(x) ismember(x,{'simplex','orthotope'}) );
  p.addParamValue('box', [zeros(d,1),ones(d,1)], @(x) (sum(size(x)==[d,2])==2) );
  p.addParamValue('order', 1 );
  p.parse(varargin{:});
  R=p.Results;
  assert( ismember(size(LN,1),[1,d]) )
  fprintf('# BENCH in dimension %d with %s mesh\n',d,R.type)
  fprintf('#d: %d\n',d)
  fprintf('#order: %d\n',R.order)
  fprintf('#type: %s\n',R.type)
  fprintf('#box: [')
  for i=1:d-1
    fprintf(' %g %g;',R.box(i,1),R.box(i,2));
  end
  fprintf(' %g %g]\n',R.box(d,1),R.box(d,2));
  dN=size(LN,1);
  if dN==1
    fprintf('#desc: %6s %10s %10s %8s\n','N','nq','nme','time(s)')
  else
    S='#desc:';
    for i=1:d, S=sprintf('%s %6s',S,sprintf('N(%d)',i));end
    fprintf('%s %10s %10s %8s\n',S,'nq','nme','time(s)');
  end
  
  
  for i=1:size(LN,2)
    tstart=tic();
    Oh=fc_hypermesh.OrthMesh(d,LN(:,i)','box',R.box,'type',R.type,'order',R.order);
    t=toc(tstart);
    if dN==1
      %fprintf('     %4d  %8d  %8d     %2.3f\n',LN(i),Oh.Mesh.nq,Oh.Mesh.nme,t);
      fprintf('       %6d %10d %10d %8s\n',LN(i),Oh.Mesh.nq,Oh.Mesh.nme,sprintf('%2.3f',t));  
    else
      S='      ';
      for j=1:d, S=sprintf('%s %6d',S,LN(j,i));end
      fprintf('%s %10d %10d %8s\n',S,Oh.Mesh.nq,Oh.Mesh.nme,sprintf('%2.3f',t));  
    end
  end
end
  
